/*
 * Copyright 2018 SMART FX sp. z o.o. All rights reserved.
 * SMARTFX PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package strategies.sample;

import com.dukascopy.api.Configurable;
import com.dukascopy.api.IAccount;
import com.dukascopy.api.IBar;
import com.dukascopy.api.IContext;
import com.dukascopy.api.IMessage;
import com.dukascopy.api.IStrategy;
import com.dukascopy.api.ITick;
import com.dukascopy.api.Instrument;
import com.dukascopy.api.JFException;
import com.dukascopy.api.Period;

/**
 *
 * @author Grzegorz Gruszka <grzegorz.gruszka at smartfx.eu>
 */
public class EquityTP implements IStrategy {

	@Configurable("Equity TP")
	public double equityTP = 1000.0;

	private IContext context;
	private Operations operations;

	@Override
	public void onStart(IContext context) throws JFException {
		this.context = context;
		this.operations = new Operations(context, equityTP);
	}

	@Override
	public void onTick(Instrument instrument, ITick tick) throws JFException {
		if (context.getAccount().getEquity() >= equityTP) {
			operations.actionOnTakeProfitLevelReached();
		}
	}

	@Override
	public void onBar(Instrument instrument, Period period, IBar askBar, IBar bidBar) throws JFException {
	}

	@Override
	public void onMessage(IMessage message) throws JFException {
	}

	@Override
	public void onAccount(IAccount account) throws JFException {
	}

	@Override
	public void onStop() throws JFException {
	}

}
